#!/usr/bin/env python
# Copyright (c) 2014, The MITRE Corporation. All rights reserved.
# See LICENSE.txt for complete terms.

import sys
from stix.core import STIXPackage


def parse_stix(pkg):

    print("== MALWARE ==")
    for tactic in pkg.ttps:
        print("---")
        print("Title : " + tactic.title)

        if tactic.behavior.attack_patterns:
            for behave in tactic.behavior.attack_patterns:
                print("CAPEC: " + str(behave.capec_id))
                print("Description: " + str(behave.description))

        if tactic.behavior.malware_instances:
            for sample in tactic.behavior.malware_instances:
                print("Sample: " + str(sample.names[0]))
                print("Type: " + str(sample.types[0]))

    print("== ACTOR ==")
    for actor in pkg.threat_actors:
        for obs in actor.observed_ttps:
            print("RelatedTTP: " + str(pkg.find(obs.item.idref).title))
            print("Relationship: " + str(obs.relationship))
        print("Title: " + str(actor.title))
        print("Name: " + str(actor.identity.name))

    return 0

if __name__ == '__main__':
    try:
        fname = sys.argv[1]
    except:
        exit(1)
    fd = open(fname)
    stix_pkg = STIXPackage.from_xml(fd)

    parse_stix(stix_pkg)
